## ME
##
# Using Animat-Ros witjh docker
#

# Info on docker image
DOCKER_IMG_NAME = ros-base-noetic
DOCKER_IMG_VER  = v1
DOCKER_IMG = ${DOCKER_IMG_NAME}:${DOCKER_IMG_VER}

# the location of the ROS workspace n the host
HOST_ROS_WS = ${HOME}/Projets/Biscuit/ROS_workdock

# info on user
USER_ID = $(shell id -u)
USER_NAME = $(shell id -un)
GROUP_ID := $(shell id -g)
GROUP_NAME := $(shell id -gn)

.PHONY: help
help:
	@echo
	@echo "make build  --> build the docker image"
	@echo "make run    --> run the docker, mounting ROS_Workspace"
	@echo "make kill   --> stop the current container, image still in «memory»"
	@echo "make remove --> stop and remove docker image"

.PHONY: run
run:
	# run docker in backgournd, mountin /ros-ws
	# then add user
	# and finaly exec an interactive shell
	docker run \
	--name rosdock \
	--detach --tty --interactive \
    --publish 127.0.0.1:9090:9090 \
	--mount type=bind,src=${HOST_ROS_WS},target="/ros-ws" \
	ros-base-noetic:v1 bash; \
	docker exec \
    --detach rosdock \
    /root/set_user_env.sh ${USER_ID} ${USER_NAME} ${GROUP_ID} ${GROUP_NAME}; \
	sleep 1; docker exec \
	--user ${USER_NAME} \
    --workdir /home/${USER_NAME} \
    --tty --interactive \
    rosdock bash

.PHONY: build
build:
	@echo "building docker image ${DOCKER_IMG}"
	@docker build -t ${DOCKER_IMG} .

.PHONY: kill
kill:
	@echo "Stopping image"
	@docker kill rosdock

.PHONY: remove
remove: kill
	@echo "kill and remove docker image"
	@docker remove rosdock

# end
